import {getFullName} from "../../helper/getFuncName";

export const getFormDTO = (essence) => {
    let dtoText = '';
    let dtoData = '';


    essence.item.map((apiItem) => {
        if(!apiItem.item && apiItem.request.method === "POST" && apiItem.request.body.mode === "formdata"){
            apiItem.request.body.formdata.map((appendDataItem) =>{
                if(appendDataItem.key.indexOf("[]") === -1){
                    dtoData += `
    ${appendDataItem.key}: string | null = null;`
                } else {
                    dtoData += `
    ${appendDataItem.key.replace("[]","")}: Interface | null = null;`
                }

            });
        }

        //проверка чтобы не было вложенностей, сказать бэкам чтобы не делали вложенностей
        if (!apiItem.item) {
            if(apiItem.request.method === "POST" && apiItem.request.body.mode === "formdata"){
                dtoText = `
export class ${getFullName(apiItem.request.url.raw.replace("{{hostUrl}}/api/", ""))}Dto {${dtoData}
}
`
            } else if (apiItem.request.method === "POST" && apiItem.request.body.mode !== "formdata"){
                if (apiItem.request.body.raw) {
                    const DTOItemKeys = Object.keys(JSON.parse(apiItem.request.body.raw))
                    const DTOItemValues = Object.values(JSON.parse(apiItem.request.body.raw))

                    const DTOItem = DTOItemKeys
                        .map((key, index) => `  ${key}: ${typeof DTOItemValues[index]} | null = null;`)
                        .join('\n')

                    dtoText += `
export class ${getFullName(apiItem.request.url.raw.replace("{{hostUrl}}/api/", ""))}Dto {
${DTOItem}
}
`
                }
            }
        }
    })

    return dtoText
}
