import {getRepositoriesTextTmp} from "./getRepositoriesTextTmp";

const fs = require('fs');

export const createApiRepositories = (essenceData, repositoriesPath) => {
    const essenceName = essenceData.name
    const apiRepositoriesText = getRepositoriesTextTmp(essenceData)

    const localRepositoriesText = `import AbstractLocalRepository from '../../base/repositories/AbstractLocalRepository';

export default class ${essenceName}LocalRepository extends AbstractLocalRepository {
    tableName(): string {
        return '';
    }
}
`



    fs.writeFileSync(`${repositoriesPath}/${essenceName}ApiRepository.ts`, apiRepositoriesText, (err) => {
        if (err) throw err;
    });

    fs.writeFileSync(`${repositoriesPath}/${essenceName}LocalRepository.ts`, localRepositoriesText, (err) => {
        if (err) throw err;
    });
}
