import {getFuncName} from "../../helper/getFuncName";

export const getRepositoriesTextTmp = (essenceData) => {
    let apiText = '';

    essenceData.item.map((apiItem) => {
        //проверка чтобы не было вложенностей, сказать бэкам чтобы не делали вложенностей
        if (!apiItem.item) {
            apiText += `
${getFuncName(apiItem.request.url.raw)} = ({data}) => {
    return this.${apiItem.request.method.toLowerCase()}({
        url: '${apiItem.request.url.raw.replace("{{hostUrl}}/api/", "")}',
        ${apiItem.request.method.toLowerCase() === "post" ? "data," : ""}
        ${apiItem.request.method.toLowerCase() === "post" && apiItem.request.body.mode === "formdata" ?
        "config: { headers: { 'Content-Type': 'multipart/form-data' }}" : ""
}
        });
}
`
        }

    })


    const finalText = `import AbstractApiRepository from '../../../base/repositories/AbstractApiRepository';
    
export default class ${essenceData.name}ApiRepository extends AbstractApiRepository {
    
    ${apiText}
    
}`;


    return finalText
}
