import {getFuncName} from "../../helper/getFuncName";

export const getServiceTmp = (essenceName, essenceData) => {

    let serviceDataText = '';

    essenceData.item.map((serviceItem) => {
        //проверка чтобы не было вложенностей, сказать бэкам чтобы не делали вложенностей
        if (!serviceItem.item) {
            serviceDataText += `
${getFuncName(serviceItem.request.url.raw)} = async ({propsData}) => {
    const { data } = await this.${essenceName.toLowerCase()}Api.${getFuncName(serviceItem.request.url.raw)}(propsData);
    // return this.${essenceName.toLowerCase()}Factory.create<ExampleModel>(ExampleModel, data?.data)
    return data;
}
`
        }
    })

    const serviceText = `import ${essenceName}Factory from './${essenceName}Factory';
import ${essenceName}ApiRepository from './repositories/${essenceName}ApiRepository';

export default class ${essenceName}Service {
  ${essenceName.toLowerCase()}Api: ${essenceName}ApiRepository;
  ${essenceName.toLowerCase()}Factory: ${essenceName}Factory;
  
  ${serviceDataText}

  constructor() {
    this.${essenceName.toLowerCase()}Api = new ${essenceName}ApiRepository();
    this.${essenceName.toLowerCase()}Factory = new ${essenceName}Factory();
  }
  
}
`
    return serviceText
}


